/* $NoKeywords:$ */
/**
 * @file
 *
 * AMD Family_14 Microcode patch.
 *
 * Fam14 Microcode Patch rev 05000028 for 5010 or equivalent.
 *
 * @xrefitem bom "File Content Label" "Release Content"
 * @e project:      AGESA
 * @e sub-project:  CPU/FAMILY/0x14
 * @e \$Revision: 37850 $   @e \$Date: 2010-09-13 18:09:57 -0400 (Mon, 13 Sep 2010) $
 *
 */
/*
 ******************************************************************************
 *
 * Copyright (c) 2011, Advanced Micro Devices, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Advanced Micro Devices, Inc. nor the names of
 *       its contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ADVANCED MICRO DEVICES, INC. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************
 */
/*----------------------------------------------------------------------------------------
 *                             M O D U L E S    U S E D
 *----------------------------------------------------------------------------------------
 */
#include "AGESA.h"
#include "cpuRegisters.h"
#include "cpuEarlyInit.h"

/*----------------------------------------------------------------------------------------
 *                   D E F I N I T I O N S    A N D    M A C R O S
 *----------------------------------------------------------------------------------------
 */

/*----------------------------------------------------------------------------------------
 *                  T Y P E D E F S     A N D     S T R U C T U R E S
 *----------------------------------------------------------------------------------------
 */

// Patch code 05000028 for 5010 and equivalent
CONST MICROCODE_PATCHES ROMDATA CpuF14MicrocodePatch05000028 =
{{
0x10,
0x20,
0x24,
0x11,
0x28,
0x00,
0x00,
0x05,
0x01,
0x80,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x10,
0x50,
0x00,
0x00,
0x00,
0xaa,
0xaa,
0xaa,
0x89,
0x66,
0x9f,
0x9a,
0x14,
0x8a,
0xcd,
0xbb,
0x71,
0x6b,
0x59,
0xe0,
0xf1,
0xec,
0x1d,
0xe2,
0xa1,
0xcb,
0xdd,
0x85,
0xd4,
0x54,
0x18,
0x05,
0x1f,
0x71,
0x70,
0x1f,
0xb5,
0x6b,
0x86,
0xa2,
0x37,
0x5e,
0x14,
0x1b,
0xdd,
0xf4,
0x40,
0x31,
0x90,
0x8a,
0xa3,
0xc1,
0x4a,
0x5c,
0xb8,
0x36,
0xf1,
0xe8,
0x7e,
0x4c,
0x2d,
0xc0,
0x51,
0x92,
0xd8,
0xb4,
0x9d,
0x6c,
0xa6,
0xd1,
0x3b,
0x6c,
0xed,
0x8e,
0x4a,
0x2e,
0xf4,
0x33,
0xbe,
0xcf,
0x57,
0xf9,
0xa2,
0x24,
0x28,
0x81,
0x63,
0x04,
0xeb,
0x75,
0x70,
0x25,
0x7d,
0xa7,
0xf2,
0xdb,
0x5e,
0xa0,
0x79,
0x5d,
0x3a,
0xd5,
0x60,
0xbb,
0x39,
0x3c,
0xe9,
0x28,
0x37,
0xe7,
0xd1,
0xf0,
0x74,
0x1b,
0x05,
0xe7,
0x7b,
0x38,
0xbe,
0x30,
0x15,
0xe8,
0x37,
0x7a,
0xc9,
0xd1,
0xc9,
0x71,
0xe3,
0x56,
0x0f,
0xae,
0x45,
0xd9,
0x26,
0x43,
0xcf,
0x87,
0x35,
0x32,
0xf9,
0xb2,
0x8c,
0xed,
0x80,
0xbe,
0xb7,
0xa3,
0x0e,
0x43,
0x6c,
0xc1,
0x9b,
0x06,
0x55,
0x93,
0xfe,
0xdd,
0x12,
0x2b,
0xcf,
0x03,
0xdd,
0xa6,
0x56,
0xf2,
0x7a,
0x82,
0xeb,
0x81,
0xf4,
0x8a,
0x43,
0x5a,
0xfe,
0xd2,
0x9d,
0xb6,
0x8e,
0x62,
0x6c,
0x01,
0x68,
0x0a,
0x65,
0x9c,
0xb5,
0x50,
0xdb,
0xa8,
0x6f,
0xea,
0x5d,
0x79,
0xce,
0xee,
0x66,
0x7f,
0xea,
0x10,
0x65,
0x79,
0x85,
0xed,
0x99,
0x01,
0xff,
0xb0,
0xa4,
0xd1,
0xc0,
0xe5,
0x6c,
0x67,
0x53,
0x25,
0x0f,
0xbb,
0xc6,
0x27,
0x93,
0xfd,
0x88,
0x92,
0xe6,
0xed,
0x4f,
0xf4,
0xfe,
0xda,
0xbf,
0x3f,
0x35,
0x2e,
0xad,
0x6e,
0xdc,
0x0e,
0xc5,
0x60,
0xc5,
0x06,
0xbf,
0x9e,
0x49,
0x5f,
0x4e,
0xf6,
0x19,
0x0a,
0x9a,
0xa1,
0x8b,
0xe2,
0xad,
0x41,
0x3d,
0x6f,
0x55,
0x3d,
0x68,
0x71,
0x66,
0xbe,
0x73,
0xed,
0x48,
0xb1,
0xfc,
0xe8,
0x7d,
0x5a,
0x6e,
0x74,
0x1e,
0xa4,
0x57,
0xe6,
0xee,
0x90,
0x44,
0xfb,
0x2d,
0x68,
0x96,
0x39,
0x4b,
0x74,
0x89,
0x4c,
0x84,
0x48,
0x42,
0x55,
0x05,
0xf1,
0x0a,
0x53,
0x2e,
0x0b,
0xe1,
0x4a,
0xf3,
0x5c,
0x9e,
0x01,
0xc5,
0x8c,
0x48,
0x28,
0xf3,
0x73,
0x59,
0xf8,
0x82,
0x6d,
0x4f,
0xb4,
0x65,
0x85,
0x19,
0xee,
0xad,
0x0b,
0x91,
0x89,
0xb6,
0x26,
0x89,
0x05,
0x95,
0xf9,
0xf2,
0xf3,
0x6a,
0x89,
0x0a,
0x73,
0x19,
0x87,
0x80,
0x1e,
0x26,
0xea,
0x87,
0xd9,
0xaa,
0x07,
0xae,
0xb5,
0x05,
0xc6,
0x2c,
0x7a,
0xc0,
0xad,
0x60,
0x67,
0x47,
0xf4,
0xd5,
0xa9,
0x21,
0x73,
0x5b,
0xa1,
0x7f,
0x4f,
0x93,
0x76,
0x41,
0xac,
0x7c,
0x68,
0x7c,
0x30,
0x6d,
0x13,
0xca,
0xcd,
0xee,
0x32,
0xcb,
0x61,
0x7f,
0xe0,
0xe6,
0x69,
0x07,
0xa7,
0x54,
0xe7,
0x20,
0xd9,
0x00,
0x23,
0x4d,
0xcd,
0xc7,
0x7b,
0x9f,
0x33,
0xb1,
0x84,
0x08,
0x38,
0x98,
0x56,
0x88,
0x4e,
0x06,
0x53,
0x57,
0x52,
0x9c,
0xb2,
0xe7,
0x45,
0x8a,
0x0b,
0x5f,
0x30,
0xde,
0x1f,
0x72,
0xfa,
0x5e,
0xd2,
0xca,
0xdc,
0xe8,
0xab,
0xd5,
0xe9,
0x34,
0xd9,
0x95,
0xf4,
0xa1,
0x21,
0xff,
0xd1,
0xda,
0xfd,
0xc4,
0x82,
0x72,
0x04,
0xb2,
0x88,
0x64,
0x19,
0x3a,
0xf9,
0x16,
0x61,
0x37,
0xda,
0xdf,
0xb5,
0xe7,
0x24,
0x60,
0xf1,
0x06,
0x2e,
0x7b,
0xb3,
0xdd,
0x56,
0x47,
0x25,
0xe5,
0x59,
0xbf,
0xe5,
0xdd,
0xd5,
0x9a,
0xa9,
0x98,
0x86,
0x90,
0xe4,
0x57,
0xa8,
0x20,
0xfa,
0xd4,
0xb6,
0x9d,
0x8c,
0x70,
0x98,
0x20,
0xf5,
0x18,
0xbd,
0x99,
0x7c,
0x2a,
0x80,
0x8a,
0x5d,
0x0b,
0x51,
0x8c,
0x9c,
0x09,
0x54,
0x42,
0x17,
0xbf,
0x66,
0x0e,
0xcd,
0x4e,
0x94,
0x72,
0x2b,
0x87,
0x0e,
0xe7,
0xf4,
0x75,
0x60,
0xf5,
0xa5,
0x0b,
0x03,
0xc4,
0x6f,
0xf8,
0x94,
0x4a,
0xbd,
0x03,
0xfb,
0xb6,
0x80,
0xa3,
0xf7,
0x7a,
0x09,
0x4c,
0x34,
0x0b,
0xee,
0x51,
0xda,
0x4e,
0x29,
0x59,
0xdc,
0x4c,
0xd9,
0x0c,
0x61,
0x8f,
0xf8,
0xb6,
0xe4,
0xf7,
0x78,
0x95,
0x1e,
0x8e,
0x9f,
0x66,
0x22,
0x1f,
0x65,
0xf6,
0xf4,
0xee,
0x82,
0x45,
0xa3,
0x52,
0x1f,
0x23,
0x4b,
0x81,
0xf1,
0x75,
0x9c,
0xdb,
0xb9,
0x76,
0xaf,
0x5c,
0xa9,
0x15,
0x3d,
0x28,
0x10,
0xc9,
0x8c,
0x4f,
0x42,
0x95,
0x5a,
0x0e,
0x81,
0x5f,
0xe8,
0x96,
0x4f,
0x8f,
0x6c,
0x16,
0xd0,
0x41,
0x1c,
0x7b,
0x90,
0x3b,
0xf5,
0x51,
0x55,
0x82,
0x68,
0xc0,
0x78,
0xb0,
0x11,
0x49,
0x22,
0x8a,
0x98,
0x42,
0x8d,
0xe7,
0x70,
0x31,
0x36,
0xb9,
0x36,
0x12,
0x99,
0x86,
0x4c,
0x0b,
0x31,
0xd9,
0xa9,
0x7c,
0xbb,
0x2e,
0x7d,
0x9a,
0x9d,
0x14,
0x22,
0x0e,
0xfe,
0xd3,
0x72,
0xfd,
0x4d,
0x84,
0x2c,
0x5f,
0x49,
0x04,
0x6d,
0x52,
0x66,
0x7b,
0x46,
0x91,
0xec,
0xea,
0x93,
0x5e,
0x8e,
0xc8,
0x64,
0xaf,
0xf8,
0xe8,
0x0b,
0x7d,
0x77,
0xa8,
0x63,
0x2e,
0xad,
0xc5,
0xf7,
0xc5,
0xfe,
0x2b,
0x91,
0x82,
0x11,
0xd6,
0xbe,
0xf8,
0x3f,
0x32,
0x30,
0x67,
0x74,
0xff,
0x3a,
0x01,
0x0d,
0x2f,
0xce,
0x87,
0x7a,
0x85,
0xb6,
0xf4,
0xf0,
0x1d,
0x3f,
0x8e,
0x3d,
0x8e,
0x2f,
0xf0,
0x64,
0x72,
0x50,
0x68,
0x3d,
0x08,
0x64,
0xcb,
0xbe,
0xfd,
0x4c,
0x17,
0x73,
0xba,
0xa4,
0x1a,
0x05,
0x5b,
0x0f,
0x4a,
0x51,
0x1b,
0x2f,
0x58,
0x2d,
0x39,
0x7f,
0x2a,
0x2a,
0x77,
0xc8,
0x69,
0xa6,
0xd1,
0x1a,
0x84,
0xbc,
0xb7,
0x6e,
0x48,
0x62,
0x07,
0x9e,
0xe2,
0x91,
0x91,
0x44,
0x9c,
0xa4,
0xfc,
0xa4,
0xc0,
0x4b,
0x47,
0x30,
0x5a,
0x00,
0xf5,
0xbb,
0x3d,
0x6c,
0x5c,
0xed,
0xe3,
0x08,
0xa0,
0x94,
0xd6,
0x1b,
0xf7,
0xf8,
0xb5,
0xd0,
0x79,
0x75,
0xf7,
0x93,
0x77,
0xc7,
0x0c,
0x0e,
0xff,
0xbd,
0xde,
0xc6,
0xbb,
0x29,
0x51,
0x3a,
0x41,
0xbe,
0x2c,
0x7d,
0xe2,
0x54,
0x60,
0x54,
0xd1,
0x73,
0xa8,
0x6a,
0x53,
0xa5,
0x8e,
0xd6,
0xb7,
0x3b,
0xc6,
0x22,
0xba,
0x3b,
0x19,
0x23,
0xf2,
0xab,
0x2d,
0xa0,
0x1f,
0x57,
0x81,
0x7a,
0x89,
0x11,
0xef,
0x57,
0x5e,
0xf8,
0x3f,
0x8c,
0xf9,
0x85,
0xc1,
0xbb,
0xe2,
0x78,
0xa6,
0x66,
0xb2,
0x1b,
0xf6,
0xfe,
0x15,
0xb8,
0xc3,
0xbc,
0xb2,
0x32,
0x6b,
0x88,
0x7a,
0xe5,
0x18,
0x6e,
0x90,
0xb3,
0x63,
0xe4,
0x14,
0x35,
0x86,
0xe1,
0x76,
0x43,
0xd0,
0x35,
0x80,
0xbd,
0x90,
0x2a,
0x9f,
0x84,
0xa6,
0x24,
0xe2,
0x00,
0x14,
0xb3,
0x67,
0x66,
0x89,
0x77,
0xae,
0x61,
0xf4,
0x78,
0xfa,
0xab,
0xc4,
0xec,
0xfe,
0x97,
0x03,
0xed,
0xa2,
0x98,
0xa0,
0xad,
0x2e,
0x4f,
0xea,
0x82,
0x43,
0xf3,
0xee,
0x7a,
0xa4,
0xff,
0x48,
0x8f,
0xca,
0x9e,
0x09,
0xb5,
0xb9,
0xcc,
0x43,
0x61,
0xfe,
0xe8,
0xd2,
0x6d,
0x36,
0x75,
0xa5,
0xf3,
0x62,
0x27,
0xd9,
0xf9,
0xab,
0xea,
0x7e,
0x49,
0x97,
0x91,
0x63,
0x86,
0x4b,
0x42,
0x43,
0xa8,
0x76,
0xe8,
0xd9,
0x02,
0x1f,
0x6d,
0xff,
0x94,
0xfb,
0xc6,
0x91,
0x7e,
0x00,
0xad,
0xee,
0xb5,
0x92,
0x4d,
0x83,
0x87,
0x65,
0xa2,
0xff,
0xb5,
0x8e,
0x86,
0xd6,
0xcf,
0x08,
0xae,
0x5b,
0xcd,
0x8c,
0x09,
0xe0,
0xa3,
0x3b,
0x97,
0xdf,
0x4f,
0x54,
0x0f,
0x12,
0x71,
0xa6,
0xec,
0x9a,
0xde,
0xc6,
0xf6,
0xf5,
0x69,
0x2a,
0xdd,
0x76,
0x61,
0xd8,
0xf0,
0x71,
0x77,
0xec,
0x44,
0x51,
0x47,
0x8c,
0xb3,
0x05,
0x03,
0x07,
0xcd,
0x8d,
0x24,
0x9e,
0x54,
0x14,
0xc5,
0xa8,
0x97,
0x97,
0x47,
0x40,
0xdd,
0xab,
0x58,
0x76,
0xd7,
0xae,
0xf1,
0x7a,
0xba,
0xc8,
0xae,
0x13,
0x45,
0x6b,
0xd7,
0xbd,
0xa9,
0x1a,
0x12,
0x82,
0x61,
0xe6,
0x23,
0xb3,
0xf1,
0xc0,
0xf6,
0x33,
0x31,
0xc8,
0xbc,
0xcf,
0x31,
0xc8,
0xc9,
0xed,
0x8a,
0xc8,
0x05,
0xd7,
0xfc,
0x78,
0xd8,
0xf3,
0xb3,
0x9a,
0x57,
0x15,
0x65,
0x4a,
0x29,
0xc7,
0x4b,
0x27,
0xfe,
0x7e,
0xf9,
0xc0,
0x19,
0x32,
0xc1,
0xe1,
0xb2,
0xfa,
0x50,
0xd8,
0x8e,
0x75,
0x15,
0xc4,
0xc4,
0xdf,
0x49,
0x69,
0xdb,
0xfa,
0x62,
0x56,
0x40,
0x3c,
0xa9,
0xf2,
0xb1,
0x57,
0xc2,
0x07,
0x6d,
0x34,
0x94,
0x3a,
0xfb,
0xdd,
0xc3,
0x23,
0x1f,
0x71,
0xa7,
0x2d,
0x51,
0x24,
0xd7,
0xcb,
0x72,
0x3d,
0xd4,
0x30,
0x07,
0x91,
0x53,
0xb0,
0x9b,
0x09,
0x1a,
0x79,
0x86,
0x4d,
0x05,
0xcc,
0x1f,
0x09,
0x40,
0x39,
0xfd,
0xf7,
0x17,
0x66,
0x9f,
0x3a,
0xe9,
0xca,
0x97,
0x5c,
0xc6,
0xc8,
0xae,
0x49,
0x1a,
0xdc,
0xc0,
0x21,
0xd6,
0xf6,
0x47,
0x5f,
0x53,
0xe9,
0xfd,
0x46,
0x14,
0x86,
0x4d,
0xc1,
0xaf,
0x5c,
0xef,
0x00,
0x25,
0x0c,
0xc1,
0x1f,
0x40,
0xc9,
0x0a,
0xe6,
0x0e,
0xec,
0xa8,
0xf6,
0x95,
0x4f,
0x22,
0x36,
0x94,
0x19,
0xc1,
0x7f,
0x82,
0xa5,
0xb1,
0xfc,
0x75,
0x11,
0x1c,
0x4f,
0x27,
0xf3,
0x5b,
0xa9,
0xd2,
0xc2,
0x78,
0xed,
0x44,
0x64,
0x76,
0xcc,
0x29,
0x36,
0x13,
0x77,
0xbe,
0xe0,
0xbc,
0x1e,
0x47,
0x22,
0x5a,
0x92,
0xc3,
0x29,
0x51,
0xb5,
0xe1,
0x90,
0x07,
0xac,
0x1c,
0x33,
0xa0,
0x50,
0x6e,
0xd1,
0xa6,
0x8f,
0x0a,
0xe8,
0x11,
0x95,
0x0d,
0xfb,
0x69,
0x88,
0x1d,
0x8f,
0xde,
0x28,
0x4f,
0xaf,
0x5f,
0x8b,
0xb1,
0xc2,
0x7f,
0x0a,
0xc8,
0x5f,
0xe7,
0x9f,
0x13,
0x9d,
0xc7,
0x6b,
0x7f,
0x42,
0x53,
0x93,
0xc4,
0xd0,
0xe3,
0x3b,
0xc9,
0x39,
0x58,
0x7e,
0x89,
0x57,
0xe6,
0x61,
0x9c,
0xc6,
0xcc,
0x0d,
0x6d,
0xbd,
0x62,
0x69,
0x38,
0xc1,
0x20,
0x86,
0x56,
0x62,
0x59,
0xbd,
0x13,
0x7d,
0xb0,
0x56,
0x2e,
0xa8,
0x38,
0xf9,
0x1f,
0xb5,
0xdc,
0x9d,
0x8c,
0xa2,
0x06,
0xb0,
0x3c,
0x73,
0x84,
0x69,
0xbd,
0xfb,
0x16,
0x54,
0xe9,
0x19,
0xb7,
0x8e,
0x01,
0x23,
0xc0,
0xd2,
0x79,
0x9d,
0x2c,
0xde,
0x50,
0x18,
0xba,
0x0b,
0xf4,
0x4d,
0x16,
0x3b,
0x54,
0x26,
0x2e,
0x9b,
0x30,
0x22,
0x3f,
0x0f,
0x52,
0xcc,
0x74,
0xa2,
0x64,
0x0e,
0x3e,
0x4e,
0x10,
0x6d,
0x5d,
0xb7,
0x3d,
0xe7,
0x31,
0x97,
0x96,
0x19,
0xdc,
0x0e,
0xd5,
0x0b,
0xc3,
0x64,
0xf6,
0xd1,
0xe6,
0xdd,
0xd2,
0x21,
0x2f,
0xfd,
0x0d,
0xbb,
0xe8,
0x78,
0xec,
0x1f,
0xbe,
0x47,
0x69,
0x1d,
0x76,
0x6a,
0x65,
0x5c,
0x10,
0x2d,
0xdc,
0x54,
0x0f,
0xa5,
0x7f,
0x30,
0x06,
0x61,
0x60,
0xea,
0xae,
0xc3,
0x17,
0xb5,
0x1f,
0xcf,
0xbe,
0xa9,
0x62,
0x0a,
0x8b,
0x52,
0x85,
0xd2,
0x12,
0x73,
0x64,
0x7d,
0xbe,
0x84,
0xc0,
0xdc,
0x9b,
0xc6,
0x5a,
0x1a,
0x3b,
0xf4,
0x1b,
0xc0,
0x9c,
0x30,
0xca,
0x72,
0x57,
0xcc,
0xca,
0x6b,
0x45,
0x8e,
0xd3,
0xf1,
0x61,
0x55,
0xc0,
0xc2,
0x13,
0x08,
0x0c,
0x75,
0x0b,
0xbd,
0x8d,
0xe3,
0xa0,
0x76,
0x73,
0x66,
0x9a,
0x6f,
0xa1,
0x3c,
0x19,
0x12,
0x75,
0x1b,
0xa9,
0xc4,
0x0f,
0xbe,
0xbc,
0xbb,
0x09,
0x15,
0x4b,
0x3a,
0x8b,
0xc5,
0x45,
0x2e,
0x91,
0x1f,
0x02,
0xdb,
0xa4,
0x8b,
0x4f,
0xd9,
0xd2,
0xcd,
0x57,
0xdb,
0x59,
0x87,
0x10,
0xe7,
0xde,
0x22,
0xec,
0x2b,
0x48,
0xd3,
0x21,
0xc8,
0x15,
0xa3,
0x25,
0x31,
0xf0,
0x4f,
0xf1,
0x4b,
0x73,
0x73,
0x09,
0x67,
0x80,
0x3b,
0x86,
0xa2,
0xc4,
0x55,
0xd5,
0x89,
0x87,
0x9f,
0x43,
0x02,
0x0e,
0xe8,
0xcc,
0xa4,
0xd4,
0xc1,
0x3c,
0x84,
0x52,
0x6b,
0x0f,
0x53,
0x89,
0x04,
0x7d,
0xd0,
0xed,
0x83,
0x2f,
0x09,
0xc4,
0x3e,
0xd6,
0xb9,
0xd0,
0xa7,
0x13,
0x6b,
0x85,
0x99,
0x22,
0x6f,
0xca,
0x59,
0xa0,
0xdb,
0x71,
0x19,
0x1f,
0x37,
0x00,
0xe2,
0x7b,
0x46,
0x81,
0xd7,
0x8e,
0xdc,
0x35,
0x25,
0x0f,
0x8d,
0x14,
0xbd,
0xfb,
0x0e,
0x14,
0xbe,
0x15,
0x64,
0xa4,
0x55,
0xad,
0xc5,
0xa3,
0xd3,
0xef,
0x97,
0x2a,
0xa0,
0x42,
0xf7,
0xb4,
0x3e,
0xc1,
0x07,
0xff,
0x5c,
0xe6,
0x32,
0x54,
0x5b,
0x71,
0x32,
0x24,
0x82,
0x21,
0xf5,
0xff,
0x27,
0x1b,
0xbf,
0x21,
0x05,
0x50,
0x04,
0x89,
0x75,
0xa4,
0xdb,
0x46,
0x59,
0xfc,
0xc6,
0xe5,
0x06,
0xe6,
0x94,
0x28,
0x3e,
0x22,
0x6a,
0x23,
0x37,
0x4c,
0xc5,
0xa1,
0x88,
0xe3,
0xc1,
0x8e,
0x41,
0xd0,
0x01,
0x1b,
0x93,
0x26,
0xc8,
0x26,
0x78,
0x78,
0x77,
0x51,
0x59,
0x7c,
0x45,
0x0e,
0x8b,
0xa7,
0x99,
0xc3,
0x5e,
0xb8,
0xd5,
0x25,
0x78,
0x4b,
0xb0,
0xdd,
0x99,
0xc7,
0x9b,
0xfc,
0xb9,
0x00,
0x4e,
0x3a,
0x88,
0xbd,
0x94,
0xf2,
0x84,
0x79,
0x53,
0x44,
0x23,
0x7c,
0x17,
0x4b,
0xab,
0xed,
0xac,
0x86,
0x58,
0x1b,
0x94,
0x16,
0x8d,
0xe8,
0xb0,
0x55,
0x5e,
0x11,
0xc3,
0x10,
0x2d,
0x53,
0x7c,
0x70,
0xbc,
0xd6,
0x5b,
0x23,
0x3f,
0x8b,
0x57,
0x23,
0x8f,
0xf5,
0xdb,
0x84,
0x88,
0x82,
0x75,
0xb0,
0xa9,
0xc6,
0x90,
0x0a,
0xe7,
0x68,
0x5b,
0x23,
0xf0,
0x08,
0x46,
0x43,
0xe7,
0x66,
0x10,
0xb5,
0xe7,
0x02,
0xc8,
0x8c,
0x16,
0x5e,
0x0e,
0x21,
0xf8,
0xc5,
0xf9,
0xee
}};

/*----------------------------------------------------------------------------------------
 *           P R O T O T Y P E S     O F     L O C A L     F U N C T I O N S
 *----------------------------------------------------------------------------------------
 */

/*----------------------------------------------------------------------------------------
 *                          E X P O R T E D    F U N C T I O N S
 *----------------------------------------------------------------------------------------
 */
